ZoneView (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.swing.text, class: ZoneView
Keywords: javax.swing.text.ZoneView class

# Class ZoneView

java.lang.Object
javax.swing.text.View
javax.swing.text.CompositeView
javax.swing.text.BoxView
javax.swing.text.ZoneView

All Implemented Interfaces:
  `SwingConstants`

public class ZoneView extends BoxView
ZoneView is a View implementation that creates zones for which the child views are not created or stored until they are needed for display or model/view translations. This enables a substantial reduction in memory consumption for situations where the model being represented is very large, by building view objects only for the region being actively viewed/edited. The size of the children can be estimated in some way, or calculated asynchronously with only the result being saved.

ZoneView extends BoxView to provide a box that implements zones for its children. The zones are special View implementations (the children of an instance of this class) that represent only a portion of the model that an instance of ZoneView is responsible for. The zones don't create child views until an attempt is made to display them. A box shaped view is well suited to this because:

- Boxes are a heavily used view, and having a box that provides this behavior gives substantial opportunity to plug the behavior into a view hierarchy from the view factory.
- Boxes are tiled in one direction, so it is easy to divide them into zones in a reliable way.
- Boxes typically have a simple relationship to the model (i.e. they create child views that directly represent the child elements).
- Boxes are easier to estimate the size of than some other shapes.

The default behavior is controlled by two properties, maxZoneSize and maxZonesLoaded. Setting maxZoneSize to Integer.MAX_VALUE would have the effect of causing only one zone to be created. This would effectively turn the view into an implementation of the decorator pattern. Setting maxZonesLoaded to a value of Integer.MAX_VALUE would cause zones to never be unloaded. For simplicity, zones are created on boundaries represented by the child elements of the element the view is responsible for. The zones can be any View implementation, but the default implementation is based upon AsyncBoxView which supports fairly large zones efficiently.

Since:
  1.3
See Also:
  - `View`

- ## Field Summary

  ### Fields declared in class View

  `BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`
  Modifier and Type
  Field
  Description
  `static final int`
  `BadBreakWeight`
  The weight to indicate a view is a bad break opportunity for the purpose of formatting.
  `static final int`
  `ExcellentBreakWeight`
  The weight to indicate a view supports breaking, and this represents a very attractive place to break.
  `static final int`
  `ForcedBreakWeight`
  The weight to indicate a view supports breaking, and must be broken to be represented properly when placed in a view that formats its children by breaking them.
  `static final int`
  `GoodBreakWeight`
  The weight to indicate a view supports breaking, but better opportunities probably exist.
  `static final int`
  `X_AXIS`
  Axis for format/break operations.
  `static final int`
  `Y_AXIS`
  Axis for format/break operations.

  ### Fields declared in interface SwingConstants

  `BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`
  Modifier and Type
  Field
  Description
  `static final int`
  `BOTTOM`
  Box-orientation constant used to specify the bottom of a box.
  `static final int`
  `CENTER`
  The central position in an area.
  `static final int`
  `EAST`
  Compass-direction east (right).
  `static final int`
  `HORIZONTAL`
  Horizontal orientation.
  `static final int`
  `LEADING`
  Identifies the leading edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `LEFT`
  Box-orientation constant used to specify the left side of a box.
  `static final int`
  `NEXT`
  Identifies the next direction in a sequence.
  `static final int`
  `NORTH`
  Compass-direction North (up).
  `static final int`
  `NORTH_EAST`
  Compass-direction north-east (upper right).
  `static final int`
  `NORTH_WEST`
  Compass-direction north west (upper left).
  `static final int`
  `PREVIOUS`
  Identifies the previous direction in a sequence.
  `static final int`
  `RIGHT`
  Box-orientation constant used to specify the right side of a box.
  `static final int`
  `SOUTH`
  Compass-direction south (down).
  `static final int`
  `SOUTH_EAST`
  Compass-direction south-east (lower right).
  `static final int`
  `SOUTH_WEST`
  Compass-direction south-west (lower left).
  `static final int`
  `TOP`
  Box-orientation constant used to specify the top of a box.
  `static final int`
  `TRAILING`
  Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
  `static final int`
  `VERTICAL`
  Vertical orientation.
  `static final int`
  `WEST`
  Compass-direction west (left).

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ZoneView(Element elem, int axis)`
  Constructs a ZoneView.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected View`
  `createZone(int p0, int p1)`
  Create a view to represent a zone for the given range within the model (which should be within the range of this objects responsibility).
  `int`
  `getMaximumZoneSize()`
  Get the current maximum zone size.
  `int`
  `getMaxZonesLoaded()`
  Get the current setting of the number of zones allowed to be loaded at the same time.
  `protected int`
  `getViewIndexAtPosition(int pos)`
  Returns the child view index representing the given position in the model.
  `void`
  `insertUpdate(DocumentEvent changes, Shape a, ViewFactory f)`
  Gives notification that something was inserted into the document in a location that this view is responsible for.
  `protected boolean`
  `isZoneLoaded(View zone)`
  Determine if a zone is in the loaded state.
  `protected void`
  `loadChildren(ViewFactory f)`
  Loads all of the children to initialize the view.
  `void`
  `removeUpdate(DocumentEvent changes, Shape a, ViewFactory f)`
  Gives notification that something was removed from the document in a location that this view is responsible for.
  `void`
  `setMaximumZoneSize(int size)`
  Set the desired maximum zone size.
  `void`
  `setMaxZonesLoaded(int mzl)`
  Sets the current setting of the number of zones allowed to be loaded at the same time.
  `protected void`
  `unloadZone(View zone)`
  Unload a zone (Convert the zone to its memory saving state).
  `protected boolean`
  `updateChildren(DocumentEvent.ElementChange ec, DocumentEvent e, ViewFactory f)`
  The superclass behavior will try to update the child views which is not desired in this case, since the children are zones and not directly effected by the changes to the associated element.
  `protected void`
  `zoneWasLoaded(View zone)`
  Called by a zone when it gets loaded.

  ### Methods declared in class BoxView

  `baselineLayout, baselineRequirements, calculateMajorAxisRequirements, calculateMinorAxisRequirements, childAllocation, flipEastAndWestAtEnds, forwardUpdate, getAlignment, getAxis, getChildAllocation, getHeight, getMaximumSpan, getMinimumSpan, getOffset, getPreferredSpan, getResizeWeight, getSpan, getViewAtPoint, getWidth, isAfter, isAllocationValid, isBefore, isLayoutValid, layout, layoutChanged, layoutMajorAxis, layoutMinorAxis, modelToView, paint, paintChild, preferenceChanged, replace, setAxis, setSize, viewToModel`
  Modifier and Type
  Method
  Description
  `protected void`
  `baselineLayout(int targetSpan, int axis, int[] offsets, int[] spans)`
  Computes the location and extent of each child view in this `BoxView` given the `targetSpan`, which is the width (or height) of the region we have to work with.
  `protected SizeRequirements`
  `baselineRequirements(int axis, SizeRequirements r)`
  Calculates the size requirements for this `BoxView` by examining the size of each child view.
  `protected SizeRequirements`
  `calculateMajorAxisRequirements(int axis, SizeRequirements r)`
  Calculates the size requirements for the major axis `axis`.
  `protected SizeRequirements`
  `calculateMinorAxisRequirements(int axis, SizeRequirements r)`
  Calculates the size requirements for the minor axis `axis`.
  `protected void`
  `childAllocation(int index, Rectangle alloc)`
  Allocates a region for a child view.
  `protected boolean`
  `flipEastAndWestAtEnds(int position, Position.Bias bias)`
  Determines in which direction the next view lays.
  `protected void`
  `forwardUpdate(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a, ViewFactory f)`
  Forwards the given `DocumentEvent` to the child views that need to be notified of the change to the model.
  `float`
  `getAlignment(int axis)`
  Determines the desired alignment for this view along an axis.
  `int`
  `getAxis()`
  Fetches the tile axis property.
  `Shape`
  `getChildAllocation(int index, Shape a)`
  Fetches the allocation for the given child view.
  `int`
  `getHeight()`
  Returns the current height of the box.
  `float`
  `getMaximumSpan(int axis)`
  Determines the maximum span for this view along an axis.
  `float`
  `getMinimumSpan(int axis)`
  Determines the minimum span for this view along an axis.
  `protected int`
  `getOffset(int axis, int childIndex)`
  Fetches the offset of a particular child's current layout.
  `float`
  `getPreferredSpan(int axis)`
  Determines the preferred span for this view along an axis.
  `int`
  `getResizeWeight(int axis)`
  Gets the resize weight.
  `protected int`
  `getSpan(int axis, int childIndex)`
  Fetches the span of a particular child's current layout.
  `protected View`
  `getViewAtPoint(int x, int y, Rectangle alloc)`
  Fetches the child view at the given coordinates.
  `int`
  `getWidth()`
  Returns the current width of the box.
  `protected boolean`
  `isAfter(int x, int y, Rectangle innerAlloc)`
  Determines if a point falls after an allocated region.
  `protected boolean`
  `isAllocationValid()`
  Are the allocations for the children still valid?
  `protected boolean`
  `isBefore(int x, int y, Rectangle innerAlloc)`
  Determines if a point falls before an allocated region.
  `protected boolean`
  `isLayoutValid(int axis)`
  Determines if the layout is valid along the given axis.
  `protected void`
  `layout(int width, int height)`
  Perform layout on the box
  `void`
  `layoutChanged(int axis)`
  Invalidates the layout along an axis.
  `protected void`
  `layoutMajorAxis(int targetSpan, int axis, int[] offsets, int[] spans)`
  Performs layout for the major axis of the box (i.e. the axis that it represents).
  `protected void`
  `layoutMinorAxis(int targetSpan, int axis, int[] offsets, int[] spans)`
  Performs layout for the minor axis of the box (i.e. the axis orthogonal to the axis that it represents).
  `Shape`
  `modelToView(int pos, Shape a, Position.Bias b)`
  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  `void`
  `paint(Graphics g, Shape allocation)`
  Renders the `BoxView` using the given rendering surface and area on that surface.
  `protected void`
  `paintChild(Graphics g, Rectangle alloc, int index)`
  Paints a child.
  `void`
  `preferenceChanged(View child, boolean width, boolean height)`
  This is called by a child to indicate its preferred span has changed.
  `void`
  `replace(int index, int length, View[] elems)`
  Invalidates the layout and resizes the cache of requests/allocations.
  `void`
  `setAxis(int axis)`
  Sets the tile axis property.
  `void`
  `setSize(float width, float height)`
  Sets the size of the view.
  `int`
  `viewToModel(float x, float y, Shape a, Position.Bias[] bias)`
  Provides a mapping from the view coordinate space to the logical coordinate space of the model.

  ### Methods declared in class CompositeView

  `getBottomInset, getInsideAllocation, getLeftInset, getNextEastWestVisualPositionFrom, getNextNorthSouthVisualPositionFrom, getNextVisualPositionFrom, getRightInset, getTopInset, getView, getViewAtPosition, getViewCount, getViewIndex, modelToView, setInsets, setParagraphInsets, setParent`
  Modifier and Type
  Method
  Description
  `protected short`
  `getBottomInset()`
  Gets the bottom inset.
  `protected Rectangle`
  `getInsideAllocation(Shape a)`
  Translates the immutable allocation given to the view to a mutable allocation that represents the interior allocation (i.e. the bounds of the given allocation with the top, left, bottom, and right insets removed.
  `protected short`
  `getLeftInset()`
  Gets the left inset.
  `protected int`
  `getNextEastWestVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Returns the next visual position for the cursor, in either the east or west direction.
  `protected int`
  `getNextNorthSouthVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Returns the next visual position for the cursor, in either the north or south direction.
  `int`
  `getNextVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
  Provides a way to determine the next visually represented model location that one might place a caret.
  `protected short`
  `getRightInset()`
  Gets the right inset.
  `protected short`
  `getTopInset()`
  Gets the top inset.
  `View`
  `getView(int n)`
  Returns the n-th view in this container.
  `protected View`
  `getViewAtPosition(int pos, Rectangle a)`
  Fetches the child view that represents the given position in the model.
  `int`
  `getViewCount()`
  Returns the number of child views of this view.
  `int`
  `getViewIndex(int pos, Position.Bias b)`
  Returns the child view index representing the given position in the model.
  `Shape`
  `modelToView(int p0, Position.Bias b0, int p1, Position.Bias b1, Shape a)`
  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
  `protected void`
  `setInsets(short top, short left, short bottom, short right)`
  Sets the insets for the view.
  `protected void`
  `setParagraphInsets(AttributeSet attr)`
  Sets the insets from the paragraph attributes specified in the given attributes.
  `void`
  `setParent(View parent)`
  Sets the parent of the view.

  ### Methods declared in class View

  `append, breakView, changedUpdate, createFragment, forwardUpdateToView, getAttributes, getBreakWeight, getContainer, getDocument, getElement, getEndOffset, getGraphics, getParent, getStartOffset, getToolTipText, getViewFactory, getViewIndex, insert, isVisible, modelToView, remove, removeAll, updateLayout, viewToModel`
  Modifier and Type
  Method
  Description
  `void`
  `append(View v)`
  Appends a single child view.
  `View`
  `breakView(int axis, int offset, float pos, float len)`
  Tries to break this view on the given axis.
  `void`
  `changedUpdate(DocumentEvent e, Shape a, ViewFactory f)`
  Gives notification from the document that attributes were changed in a location that this view is responsible for.
  `View`
  `createFragment(int p0, int p1)`
  Creates a view that represents a portion of the element.
  `protected void`
  `forwardUpdateToView(View v, DocumentEvent e, Shape a, ViewFactory f)`
  Forwards the `DocumentEvent` to the give child view.
  `AttributeSet`
  `getAttributes()`
  Fetches the attributes to use when rendering.
  `int`
  `getBreakWeight(int axis, float pos, float len)`
  Determines how attractive a break opportunity in this view is.
  `Container`
  `getContainer()`
  Fetches the container hosting the view.
  `Document`
  `getDocument()`
  Fetches the model associated with the view.
  `Element`
  `getElement()`
  Fetches the structural portion of the subject that this view is mapped to.
  `int`
  `getEndOffset()`
  Fetches the portion of the model for which this view is responsible.
  `Graphics`
  `getGraphics()`
  Fetch a `Graphics` for rendering.
  `View`
  `getParent()`
  Returns the parent of the view.
  `int`
  `getStartOffset()`
  Fetches the portion of the model for which this view is responsible.
  `String`
  `getToolTipText(float x, float y, Shape allocation)`
  Returns the tooltip text at the specified location.
  `ViewFactory`
  `getViewFactory()`
  Fetches the `ViewFactory` implementation that is feeding the view hierarchy.
  `int`
  `getViewIndex(float x, float y, Shape allocation)`
  Returns the child view index representing the given position in the view.
  `void`
  `insert(int offs, View v)`
  Inserts a single child view.
  `boolean`
  `isVisible()`
  Returns a boolean that indicates whether the view is visible or not.
  `Shape`
  `modelToView(int pos, Shape a)`
  Deprecated.
  `void`
  `remove(int i)`
  Removes one of the children at the given position.
  `void`
  `removeAll()`
  Removes all of the children.
  `protected void`
  `updateLayout(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a)`
  Updates the layout in response to receiving notification of change from the model.
  `int`
  `viewToModel(float x, float y, Shape a)`
  Deprecated.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### ZoneView

    public ZoneView(Element elem, int axis)
    Constructs a ZoneView.
    Parameters:
      `elem` - the element this view is responsible for
      `axis` - either View.X_AXIS or View.Y_AXIS

- ## Method Details

  - ### getMaximumZoneSize

    public int getMaximumZoneSize()
    Get the current maximum zone size.
    Returns:
      the current maximum zone size

  - ### setMaximumZoneSize

    public void setMaximumZoneSize(int size)
    Set the desired maximum zone size. A zone may get larger than this size if a single child view is larger than this size since zones are formed on child view boundaries.
    Parameters:
      `size` - the number of characters the zone may represent before attempting to break the zone into a smaller size.

  - ### getMaxZonesLoaded

    public int getMaxZonesLoaded()
    Get the current setting of the number of zones allowed to be loaded at the same time.
    Returns:
      current setting of the number of zones allowed to be loaded at the same time

  - ### setMaxZonesLoaded

    public void setMaxZonesLoaded(int mzl)
    Sets the current setting of the number of zones allowed to be loaded at the same time. This will throw an `IllegalArgumentException` if `mzl` is less than 1.
    Parameters:
      `mzl` - the desired maximum number of zones to be actively loaded, must be greater than 0
    Throws:
      `IllegalArgumentException` - if `mzl` is < 1

  - ### zoneWasLoaded

    protected void zoneWasLoaded(View zone)
    Called by a zone when it gets loaded. This happens when an attempt is made to display or perform a model/view translation on a zone that was in an unloaded state. This is implemented to check if the maximum number of zones was reached and to unload the oldest zone if so.
    Parameters:
      `zone` - the child view that was just loaded.

  - ### unloadZone

    protected void unloadZone(View zone)
    Unload a zone (Convert the zone to its memory saving state). The zones are expected to represent a subset of the child elements of the element this view is responsible for. Therefore, the default implementation is to simple remove all the children.
    Parameters:
      `zone` - the child view desired to be set to an unloaded state.

  - ### isZoneLoaded

    protected boolean isZoneLoaded(View zone)
    Determine if a zone is in the loaded state. The zones are expected to represent a subset of the child elements of the element this view is responsible for. Therefore, the default implementation is to return true if the view has children. param zone the child view
    Parameters:
      `zone` - the zone
    Returns:
      whether or not the zone is in the loaded state.

  - ### createZone

    protected View createZone(int p0, int p1)
    Create a view to represent a zone for the given range within the model (which should be within the range of this objects responsibility). This is called by the zone management logic to create new zones. Subclasses can provide a different implementation for a zone by changing this method.
    Parameters:
      `p0` - the start of the desired zone. This should be >= getStartOffset() and < getEndOffset(). This value should also be < p1.
      `p1` - the end of the desired zone. This should be > getStartOffset() and <= getEndOffset(). This value should also be > p0.
    Returns:
      a view to represent a zone for the given range within the model

  - ### loadChildren

    protected void loadChildren(ViewFactory f)
    Loads all of the children to initialize the view. This is called by the `setParent` method. This is reimplemented to not load any children directly (as they are created by the zones). This method creates the initial set of zones. Zones don't actually get populated however until an attempt is made to display them or to do model/view coordinate translation.
    Overrides:
      `loadChildren` in class `CompositeView`
    Parameters:
      `f` - the view factory
    See Also:
      - `CompositeView.setParent(View)`

  - ### getViewIndexAtPosition

    protected int getViewIndexAtPosition(int pos)
    Returns the child view index representing the given position in the model.
    Overrides:
      `getViewIndexAtPosition` in class `CompositeView`
    Parameters:
      `pos` - the position >= 0
    Returns:
      index of the view representing the given position, or -1 if no view represents that position

  - ### updateChildren

    protected boolean updateChildren(DocumentEvent.ElementChange ec, DocumentEvent e, ViewFactory f)
    The superclass behavior will try to update the child views which is not desired in this case, since the children are zones and not directly effected by the changes to the associated element. This is reimplemented to do nothing and return false.
    Overrides:
      `updateChildren` in class `View`
    Parameters:
      `ec` - the change information for the element this view is responsible for. This should not be `null` if this method gets called
      `e` - the change information from the associated document
      `f` - the factory to use to build child views
    Returns:
      whether or not the child views represent the child elements of the element this view is responsible for. Some views create children that represent a portion of the element they are responsible for, and should return false. This information is used to determine if views in the range of the added elements should be forwarded to or not
    See Also:
      - `View.insertUpdate(DocumentEvent, Shape, ViewFactory)`
      - `View.removeUpdate(DocumentEvent, Shape, ViewFactory)`
      - `View.changedUpdate(DocumentEvent, Shape, ViewFactory)`

  - ### insertUpdate

    public void insertUpdate(DocumentEvent changes, Shape a, ViewFactory f)
    Gives notification that something was inserted into the document in a location that this view is responsible for. This is largely delegated to the superclass, but is reimplemented to update the relevant zone (i.e. determine if a zone needs to be split into a set of 2 or more zones).
    Overrides:
      `insertUpdate` in class `View`
    Parameters:
      `changes` - the change information from the associated document
      `a` - the current allocation of the view
      `f` - the factory to use to rebuild if the view has children
    See Also:
      - `View.insertUpdate(DocumentEvent, Shape, ViewFactory)`

  - ### removeUpdate

    public void removeUpdate(DocumentEvent changes, Shape a, ViewFactory f)
    Gives notification that something was removed from the document in a location that this view is responsible for. This is largely delegated to the superclass, but is reimplemented to update the relevant zones (i.e. determine if zones need to be removed or joined with another zone).
    Overrides:
      `removeUpdate` in class `View`
    Parameters:
      `changes` - the change information from the associated document
      `a` - the current allocation of the view
      `f` - the factory to use to rebuild if the view has children
    See Also:
      - `View.removeUpdate(DocumentEvent, Shape, ViewFactory)`